* RS2DBF.prg - Converts an ADO recordset into a cursor or DBF.
* Author: Ken R. Levy
* 

#INCLUDE "adovfp.h"
#INCLUDE "dbf2rs.h"


LPARAMETERS rs,tcTable
LOCAL lcTable,lcAlias,lcScope,lcDBF,lnDataTypeEnum,lnLastAbsolutePosition
LOCAL lvValue,lnFieldCount,lcField,lcFieldType,lnFieldSize,lnFieldAttributes
LOCAL lnCount,lnCount2,lnRecNo,lnLastSelect,llRecNoColumn,llMatch
LOCAL lvFieldValue,lnFieldPrecision,lnRecCount,llCreateTable,oField,lcFileName
DIMENSION laFields[1,16]

IF NOT INLIST(VARTYPE(rs),"O","C")
	RETURN ""
ENDIF
IF VARTYPE(rs)=="C"
	lcFileName=ALLTRIM(rs)
	IF EMPTY(lcFileName) OR NOT FILE(lcFileName)
		RETURN ""
	ENDIF
	rs=NEWOBJECT("ADODB.Recordset")
	IF VARTYPE(rs)#"O"
		RETURN ""
	ENDIF
	rs.cursorLocation=ADUSECLIENT
	rs.cursorType=ADOPENSTATIC
	rs.lockType=ADLOCKOPTIMISTIC
	rs.open(lcFileName)
ENDIF
IF TYPE("rs.recordCount")#"N"
	RETURN ""
ENDIF
llRecNoColumn=(LOWER(rs.fields(0).name)==LOWER(F_RECNO_FIELD))
lnLastSelect=SELECT()
IF NOT INLIST(VARTYPE(tcTable),"C","L") OR EMPTY(tcTable)
	lcTable=LOWER(SYS(2015))
ELSE
	lcTable=LOWER(IIF(EMPTY(tcTable),ALIAS(),ALLTRIM(tcTable)))
ENDIF
IF "."$lcTable
	lcDBF=lcTable
	lcAlias=LOWER(SYS(2015))
	IF FILE(lcDBF)
		SELECT 0
		USE (lcDBF) ALIAS (lcAlias) AGAIN SHARED
	ENDIF
ELSE
	lcDBF=""
	lcAlias=lcTable
ENDIF
lnFieldCount=rs.fields.count-IIF(llRecNoColumn,1,0)
llCreateTable=.F.
IF NOT USED(lcAlias)
	llMatch=.T.
	lnCount2=0
	FOR lnCount = 1 TO lnFieldCount
		oField=rs.fields(lnCount-IIF(llRecNoColumn,0,1))
		lcField=CHRTRAN(oField.Name,"- ","__")
		IF not EMPTY(lcDBF)
			lcField=LEFT(lcField,10)
		endIF not EMPTY(lcDBF)
		lnFieldSize=oField.DefinedSize
		lnDataTypeEnum=oField.Type
		lnFieldPrecision=0
		lnFieldAttributes=oField.Attributes
		DO CASE
			CASE lnDataTypeEnum=ADCHAR OR lnDataTypeEnum=ADVARCHAR
				IF lnFieldSize>=255
					lcFieldType="M"
					lnFieldSize=4
				ELSE
					lcFieldType="C"
				ENDIF
			CASE lnDataTypeEnum=ADVARWCHAR or lnDataTypeEnum = ADLONGVARWCHAR or ;
				lnDataTypeEnum = ADGUID
				lcFieldType="M"
				lnFieldSize=4
			CASE lnDataTypeEnum=ADBOOLEAN
				lcFieldType="L"
				lnFieldSize=1
			CASE lnDataTypeEnum=ADDBDATE
				lcFieldType="D"
			CASE lnDataTypeEnum=ADDBTIMESTAMP
				lcFieldType="T"
				lnFieldSize=8
			CASE lnDataTypeEnum=ADSINGLE
				lcFieldType="N"
				lnFieldPrecision=oField.Precision
			CASE lnDataTypeEnum=ADDOUBLE
				lcFieldType="B"
				lnFieldPrecision=oField.Precision
			CASE lnDataTypeEnum=ADINTEGER or lnDataTypeEnum = ADUNSIGNEDINT or ;
				lnDataTypeEnum = ADUNSIGNEDSMALLINT or lnDataTypeEnum = ADSMALLINT
				lcFieldType="I"
			CASE lnDataTypeEnum=ADDOUBLE
				lcFieldType="F"
				lnFieldPrecision=oField.Precision
			CASE lnDataTypeEnum=ADCURRENCY
				lcFieldType="Y"
				lnFieldPrecision=oField.Precision
			CASE lnDataTypeEnum=ADVARIANT
				lcFieldType="C"
			OTHERWISE
				LOOP
		ENDCASE
		llCreateTable=.T.
		lnCount2=lnCount2+1
		DIMENSION laFields[lnCount2,16]
		laFields[lnCount2,1]=lcField
		laFields[lnCount2,2]=lcFieldType
		laFields[lnCount2,3]=lnFieldSize
		laFields[lnCount2,4]=lnFieldPrecision
		laFields[lnCount2,5]=BITTEST(lnFieldAttributes,5)
		laFields[lnCount2,6]=.F.
		laFields[lnCount2,7]=""
		laFields[lnCount2,8]=""
		laFields[lnCount2,9]=""
		laFields[lnCount2,10]=""
		laFields[lnCount2,11]=""
		laFields[lnCount2,12]=""
		laFields[lnCount2,13]=""
		laFields[lnCount2,14]=""
		laFields[lnCount2,15]=""
		laFields[lnCount2,16]=""
	ENDFOR
	IF NOT llCreateTable
		SELECT (lnLastSelect)
		RETURN ""
	ENDIF
	IF EMPTY(lcDBF)
		CREATE CURSOR (lcAlias) FROM ARRAY laFields
	ELSE
		CREATE TABLE (lcDBF) FROM ARRAY laFields
		USE
		IF FILE(lcDBF)
			SELECT 0
			USE (lcDBF) ALIAS (lcAlias) AGAIN SHARED
		ENDIF
	ENDIF
	IF NOT USED(lcAlias)
		SELECT (lnLastSelect)
		RETURN ""
	ENDIF
ENDIF
lnRecCount=RECCOUNT()
IF rs.BOF OR rs.EOF
	IF rs.recordCount>0
		rs.moveFirst
		lnLastAbsolutePosition=rs.absolutePosition
	ELSE
		lnLastAbsolutePosition=0
	ENDIF
ELSE
	lnLastAbsolutePosition=rs.absolutePosition
ENDIF

lnCount = 0
rs.MoveFirst()
do while not rs.EOF
	lnCount = lnCount + 1
***	rs.absolutePosition=lnCount
	lnRecNo=IIF(llRecNoColumn,rs.fields(F_RECNO_FIELD).value,lnCount)
	IF VARTYPE(lnRecNo)#"N"
		lnRecNo=0
	ENDIF
	DO CASE
		CASE lnRecNo<0 OR (NOT llCreateTable AND llRecNoColumn AND ;
				lnRecNo>RECCOUNT())
			LOOP
		CASE NOT BETWEEN(lnRecNo,1,lnRecCount)
			APPEND BLANK
			lnRecNo=RECNO()
			IF llRecNoColumn AND (rs.lockType=ADLOCKOPTIMISTIC OR ;
					rs.lockType=ADLOCKBATCHOPTIMISTIC)
				rs.fields(F_RECNO_FIELD).value=lnRecNo
			ENDIF
	ENDCASE
	GO lnRecNo
	FOR lnCount2 = 1 TO lnFieldCount
		oField=rs.fields(lnCount2-IIF(llRecNoColumn,0,1))
		lcField=oField.name
		lvValue=oField.value
		lcFieldType=TYPE(lcField)
		IF NOT INLIST(lcFieldType,"C","M","L","D","T","N","I","F","B","Y")
			LOOP
		ENDIF
		lvFieldValue=EVALUATE(lcField)
		IF NOT VARTYPE(lvFieldValue)==VARTYPE(lvValue)
			DO CASE
				CASE lcFieldType=="T" 
					IF EMPTY(lvValue)
						lvValue={^1980/01/01 12:00:00 AM}
					ELSE
						lvValue=DTOT(lvValue)
					ENDIF
				CASE lcFieldType=="D"
					IF EMPTY(lvValue)
						lvValue={^1980/01/01}
					ELSE
						lvValue=TTOD(lvValue)
					ENDIF
				OTHERWISE
					LOOP
			ENDCASE
		ENDIF
		IF lvFieldValue==lvValue
			LOOP
		ENDIF
		REPLACE (lcField) WITH lvValue
	ENDFOR
	rs.MoveNext()
enddo
IF lnLastAbsolutePosition>0
*	rs.absolutePosition=lnLastAbsolutePosition
ENDIF
LOCATE
RETURN lcAlias
